﻿
Task t = new Task(() => {
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: task is starting ...");
	Thread.Sleep(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: task is ending ...");
});

Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: unstarted task created ...");

try {
	Parallel.For(0, 5, i => {
		Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Parallel.For() iteration {i} calling t.Start() ...");
		t.Start();
	});
} catch (AggregateException ex) {
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: AggregateException with {ex.InnerExceptions.Count} InnerExceptions caught:");
	Console.WriteLine(ex);
}

Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: in Main: all done!");

