﻿public class Program {

	public static void f1(int a, int b) {
		int c = a + b;

		{
			Action<int> updateDelegate = x => c += x;
			updateDelegate(10);
			updateDelegate(100);
		}

		{
			Action<int> updateDelegate = x => c += x;
			updateDelegate(1000);
		}

        Console.WriteLine($"f1: c == {c}");
    }

	public static void Main(string[] args) {
		f1(1, 2);
		f2(1, 2);

        Console.WriteLine();
        f3(1, 2);
		f4(1, 2);
	}

	public static void f2(int a, int b) {
		int c = a + b;

		{
			Action<int> updateDelegate = addXToC;
			updateDelegate(10);
			updateDelegate(100);
		}

		{
			Action<int> updateDelegate = addXToC; 
			updateDelegate(1000);
		}

		Console.WriteLine($"f2: c == {c}");

		void addXToC(int x) {
			c += x;
		}
	}

	public static void f3(int a, int b) {
		{
			int c = a + b;
			Action<int> updateDelegate = addXToC;
			updateDelegate(10);
			updateDelegate(100);
			Console.WriteLine($"f3: c == {c}");
		}

		{
			int c = 1000;
			Action<int> updateDelegate = addXToC;
			updateDelegate(1000);
			Console.WriteLine($"f3: c == {c}");
		}

		void addXToC(int x) {
			// Error: The name 'c' does not exist in the current context
			// c += x;
		}
	}

	public static void f4(int a, int b) {
		{
			int c = a + b;
			Action<int> updateDelegate = addXToC;
			updateDelegate(10);
			updateDelegate(100);
			Console.WriteLine($"f4: c == {c}");

			void addXToC(int x) {
				c += x;
			}
		}

		{
			int c = 1000;
			Action<int> updateDelegate = addXToC;
			updateDelegate(1000);
			Console.WriteLine($"f4: c == {c}");

			void addXToC(int x) {
				c += x;
			}
		}
	}
}
